/*******************************************************************************
 *
 * blueMarine - open source photo workflow
 * =======================================
 *
 * Copyright (C) 2003-2009 by Fabrizio Giudici
 * Project home page: http://bluemarine.tidalwave.it
 *
 *******************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); 
 * you may not use this file except in compliance with the License. 
 * You may obtain a copy of the License at 
 * 
 *     http://www.apache.org/licenses/LICENSE-2.0 
 * 
 * Unless required by applicable law or agreed to in writing, software 
 * distributed under the License is distributed on an "AS IS" BASIS, 
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
 * See the License for the specific language governing permissions and 
 * limitations under the License. 
 *
 *******************************************************************************
 *
 * $Id: BasicMetadataPane.java,v d60681e7fc1d 2009/09/17 23:59:23 fabrizio $
 *
 ******************************************************************************/
package it.tidalwave.metadata.viewer.impl;

import it.tidalwave.metadata.basic.Basic;
import it.tidalwave.swing.beansbinding.AbstractBindablePane;

/*******************************************************************************
 *
 * @author  Fabrizio Giudici
 * @version $Id: BasicMetadataPane.java,v d60681e7fc1d 2009/09/17 23:59:23 fabrizio $
 *
 ******************************************************************************/
@edu.umd.cs.findbugs.annotations.SuppressWarnings(value={"SE_BAD_FIELD"}, justification="bindingGroup is generated by NetBeans")
public class BasicMetadataPane extends AbstractBindablePane<Basic>
  {
    public BasicMetadataPane() 
      {
        initComponents();
        initialize("basic", bindingGroup);
      }
    
    /** 
     * This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {
        bindingGroup = new org.jdesktop.beansbinding.BindingGroup();

        commaSeparatedListConverter = new it.tidalwave.swing.beansbinding.converter.CommaSeparatedListConverter();
        dateConverter = new it.tidalwave.swing.beansbinding.converter.DateConverter();
        basic = new it.tidalwave.metadata.basic.Basic();
        lbFileName = new javax.swing.JLabel();
        lbSidecarFiles = new javax.swing.JLabel();
        lbFolder = new javax.swing.JLabel();
        lbFileSize = new javax.swing.JLabel();
        lbFileType = new javax.swing.JLabel();
        lbMetadataDate = new javax.swing.JLabel();
        lbMetadataStatus = new javax.swing.JLabel();
        tfFileName = new javax.swing.JTextField();
        tfSidecarFiles = new javax.swing.JTextField();
        tfFolder = new javax.swing.JTextField();
        tfFileSize = new javax.swing.JTextField();
        tfFileType = new javax.swing.JTextField();
        tfMetadataStatus = new javax.swing.JTextField();
        tfMetadataDate = new javax.swing.JTextField();

        setName("Form"); // NOI18N

        lbFileName.setFont(lbFileName.getFont().deriveFont(lbFileName.getFont().getSize()-2f));
        lbFileName.setHorizontalAlignment(javax.swing.SwingConstants.TRAILING);
        lbFileName.setText(org.openide.util.NbBundle.getMessage(BasicMetadataPane.class, "BasicMetadataPane.lbFileName.text")); // NOI18N
        lbFileName.setName("lbFileName"); // NOI18N

        lbSidecarFiles.setFont(lbSidecarFiles.getFont().deriveFont(lbSidecarFiles.getFont().getSize()-2f));
        lbSidecarFiles.setHorizontalAlignment(javax.swing.SwingConstants.TRAILING);
        lbSidecarFiles.setText(org.openide.util.NbBundle.getMessage(BasicMetadataPane.class, "BasicMetadataPane.lbSidecarFiles.text")); // NOI18N
        lbSidecarFiles.setName("lbSidecarFiles"); // NOI18N

        lbFolder.setFont(lbFolder.getFont().deriveFont(lbFolder.getFont().getSize()-2f));
        lbFolder.setHorizontalAlignment(javax.swing.SwingConstants.TRAILING);
        lbFolder.setText(org.openide.util.NbBundle.getMessage(BasicMetadataPane.class, "BasicMetadataPane.lbFolder.text")); // NOI18N
        lbFolder.setName("lbFolder"); // NOI18N

        lbFileSize.setFont(lbFileSize.getFont().deriveFont(lbFileSize.getFont().getSize()-2f));
        lbFileSize.setHorizontalAlignment(javax.swing.SwingConstants.TRAILING);
        lbFileSize.setText(org.openide.util.NbBundle.getMessage(BasicMetadataPane.class, "BasicMetadataPane.lbFileSize.text")); // NOI18N
        lbFileSize.setName("lbFileSize"); // NOI18N

        lbFileType.setFont(lbFileType.getFont().deriveFont(lbFileType.getFont().getSize()-2f));
        lbFileType.setHorizontalAlignment(javax.swing.SwingConstants.TRAILING);
        lbFileType.setText(org.openide.util.NbBundle.getMessage(BasicMetadataPane.class, "BasicMetadataPane.lbFileType.text")); // NOI18N
        lbFileType.setName("lbFileType"); // NOI18N

        lbMetadataDate.setFont(lbMetadataDate.getFont().deriveFont(lbMetadataDate.getFont().getSize()-2f));
        lbMetadataDate.setHorizontalAlignment(javax.swing.SwingConstants.TRAILING);
        lbMetadataDate.setText(org.openide.util.NbBundle.getMessage(BasicMetadataPane.class, "BasicMetadataPane.lbMetadataDate.text")); // NOI18N
        lbMetadataDate.setName("lbMetadataDate"); // NOI18N

        lbMetadataStatus.setFont(lbMetadataStatus.getFont().deriveFont(lbMetadataStatus.getFont().getSize()-2f));
        lbMetadataStatus.setHorizontalAlignment(javax.swing.SwingConstants.TRAILING);
        lbMetadataStatus.setText(org.openide.util.NbBundle.getMessage(BasicMetadataPane.class, "BasicMetadataPane.lbMetadataStatus.text")); // NOI18N
        lbMetadataStatus.setName("lbMetadataStatus"); // NOI18N

        tfFileName.setFont(tfFileName.getFont().deriveFont(tfFileName.getFont().getSize()-2f));
        tfFileName.setName("tfFileName"); // NOI18N

        org.jdesktop.beansbinding.Binding binding = org.jdesktop.beansbinding.Bindings.createAutoBinding(org.jdesktop.beansbinding.AutoBinding.UpdateStrategy.READ_WRITE, basic, org.jdesktop.beansbinding.ELProperty.create("${fileName}"), tfFileName, org.jdesktop.beansbinding.BeanProperty.create("text"));
        bindingGroup.addBinding(binding);

        tfSidecarFiles.setEditable(false);
        tfSidecarFiles.setFont(tfSidecarFiles.getFont().deriveFont(tfSidecarFiles.getFont().getSize()-2f));
        tfSidecarFiles.setName("tfSidecarFiles"); // NOI18N

        binding = org.jdesktop.beansbinding.Bindings.createAutoBinding(org.jdesktop.beansbinding.AutoBinding.UpdateStrategy.READ_WRITE, basic, org.jdesktop.beansbinding.ELProperty.create("${sidecars}"), tfSidecarFiles, org.jdesktop.beansbinding.BeanProperty.create("text"));
        binding.setConverter(commaSeparatedListConverter);
        bindingGroup.addBinding(binding);

        tfFolder.setEditable(false);
        tfFolder.setFont(tfFolder.getFont().deriveFont(tfFolder.getFont().getSize()-2f));
        tfFolder.setName("tfFolder"); // NOI18N

        binding = org.jdesktop.beansbinding.Bindings.createAutoBinding(org.jdesktop.beansbinding.AutoBinding.UpdateStrategy.READ_WRITE, basic, org.jdesktop.beansbinding.ELProperty.create("${folder}"), tfFolder, org.jdesktop.beansbinding.BeanProperty.create("text"));
        bindingGroup.addBinding(binding);

        tfFileSize.setEditable(false);
        tfFileSize.setFont(tfFileSize.getFont().deriveFont(tfFileSize.getFont().getSize()-2f));
        tfFileSize.setName("tfFileSize"); // NOI18N

        binding = org.jdesktop.beansbinding.Bindings.createAutoBinding(org.jdesktop.beansbinding.AutoBinding.UpdateStrategy.READ_WRITE, basic, org.jdesktop.beansbinding.ELProperty.create("${fileSize}"), tfFileSize, org.jdesktop.beansbinding.BeanProperty.create("text"));
        bindingGroup.addBinding(binding);

        tfFileType.setEditable(false);
        tfFileType.setFont(tfFileType.getFont().deriveFont(tfFileType.getFont().getSize()-2f));
        tfFileType.setName("tfFileType"); // NOI18N

        binding = org.jdesktop.beansbinding.Bindings.createAutoBinding(org.jdesktop.beansbinding.AutoBinding.UpdateStrategy.READ_WRITE, basic, org.jdesktop.beansbinding.ELProperty.create("${mimeType}"), tfFileType, org.jdesktop.beansbinding.BeanProperty.create("text"));
        bindingGroup.addBinding(binding);

        tfMetadataStatus.setEditable(false);
        tfMetadataStatus.setFont(tfMetadataStatus.getFont().deriveFont(tfMetadataStatus.getFont().getSize()-2f));
        tfMetadataStatus.setName("tfMetadataStatus"); // NOI18N

        binding = org.jdesktop.beansbinding.Bindings.createAutoBinding(org.jdesktop.beansbinding.AutoBinding.UpdateStrategy.READ_WRITE, basic, org.jdesktop.beansbinding.ELProperty.create("${metadataStatus}"), tfMetadataStatus, org.jdesktop.beansbinding.BeanProperty.create("text"));
        bindingGroup.addBinding(binding);

        tfMetadataDate.setEditable(false);
        tfMetadataDate.setFont(tfMetadataDate.getFont().deriveFont(tfMetadataDate.getFont().getSize()-2f));
        tfMetadataDate.setName("tfMetadataDate"); // NOI18N

        binding = org.jdesktop.beansbinding.Bindings.createAutoBinding(org.jdesktop.beansbinding.AutoBinding.UpdateStrategy.READ_WRITE, basic, org.jdesktop.beansbinding.ELProperty.create("${latestModificationDateTime}"), tfMetadataDate, org.jdesktop.beansbinding.BeanProperty.create("text"));
        binding.setSourceNullValue("n.a.");
        binding.setSourceUnreadableValue("n.a.");
        binding.setConverter(dateConverter);
        bindingGroup.addBinding(binding);

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(lbSidecarFiles)
                    .add(lbFileName, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 120, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(lbFolder)
                    .add(lbFileSize)
                    .add(lbFileType)
                    .add(lbMetadataStatus)
                    .add(lbMetadataDate))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(tfMetadataDate, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 93, Short.MAX_VALUE)
                    .add(tfMetadataStatus, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 93, Short.MAX_VALUE)
                    .add(tfFileType, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 93, Short.MAX_VALUE)
                    .add(tfFileSize, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 93, Short.MAX_VALUE)
                    .add(tfFolder, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 93, Short.MAX_VALUE)
                    .add(tfSidecarFiles, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 93, Short.MAX_VALUE)
                    .add(tfFileName, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 93, Short.MAX_VALUE)))
        );

        layout.linkSize(new java.awt.Component[] {lbFileName, lbFileSize, lbFileType, lbFolder, lbMetadataDate, lbMetadataStatus, lbSidecarFiles}, org.jdesktop.layout.GroupLayout.HORIZONTAL);

        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(lbFileName)
                    .add(tfFileName, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .add(2, 2, 2)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(lbSidecarFiles)
                    .add(tfSidecarFiles, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .add(2, 2, 2)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(lbFolder)
                    .add(tfFolder, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .add(2, 2, 2)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(lbFileSize)
                    .add(tfFileSize, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .add(2, 2, 2)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(lbFileType)
                    .add(tfFileType, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .add(2, 2, 2)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(lbMetadataStatus)
                    .add(tfMetadataStatus, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .add(2, 2, 2)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(lbMetadataDate)
                    .add(tfMetadataDate, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)))
        );

        bindingGroup.bind();
    }// </editor-fold>//GEN-END:initComponents
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    public it.tidalwave.metadata.basic.Basic basic;
    protected transient it.tidalwave.swing.beansbinding.converter.CommaSeparatedListConverter commaSeparatedListConverter;
    protected transient it.tidalwave.swing.beansbinding.converter.DateConverter dateConverter;
    protected javax.swing.JLabel lbFileName;
    protected javax.swing.JLabel lbFileSize;
    protected javax.swing.JLabel lbFileType;
    protected javax.swing.JLabel lbFolder;
    protected javax.swing.JLabel lbMetadataDate;
    protected javax.swing.JLabel lbMetadataStatus;
    protected javax.swing.JLabel lbSidecarFiles;
    protected javax.swing.JTextField tfFileName;
    protected javax.swing.JTextField tfFileSize;
    protected javax.swing.JTextField tfFileType;
    protected javax.swing.JTextField tfFolder;
    protected javax.swing.JTextField tfMetadataDate;
    protected javax.swing.JTextField tfMetadataStatus;
    protected javax.swing.JTextField tfSidecarFiles;
    private org.jdesktop.beansbinding.BindingGroup bindingGroup;
    // End of variables declaration//GEN-END:variables
  }
